package com.sillycycle.bagleyd.abacus.view;

import android.content.Context;

//import com.sillycycle.bagleyd.util.Graphics;

import android.graphics.Canvas;
import android.graphics.Color;
import android.graphics.Paint;
import android.graphics.Paint.Style;
import android.util.AttributeSet;
import android.view.View;

import com.sillycycle.bagleyd.abacus.Abacus;
import com.sillycycle.bagleyd.abacus.AbacusCanvas;
import com.sillycycle.bagleyd.abacus.AbacusInterface;
//import com.sillycycle.bagleyd.abacus.AbacusCanvas.BeadMoveListener;
import com.sillycycle.bagleyd.abacus.model.AbacusFormat;
import com.sillycycle.bagleyd.abacus.model.NumberField;

/**
 *
 * @author <a href="mailto:bagleyd AT verizon.net">David Bagley</a>
 */
public class AbacusView extends View {

	private static volatile AbacusFormat model = null;
	private static volatile NumberField field = null;
	private static volatile AbacusGeometry geo = null;
	private static volatile AbacusDraw aDraw = null;
	private static volatile AbacusCanvas aCanvas = null;
	private static volatile Paint paint = null;

	/**
	 * @param context the rest of the application
	 */
	public AbacusView(Context context) {
		super(context);
		setFocusableInTouchMode(true);
	}

	//FIXME
	public Abacus getAbacus(int aux) {return null;}
	public boolean mainAbacus(AbacusCanvas canvas) { return true;}
	public void toggleSound(){}
	public void descriptionHelp(){}
	public void featuresHelp(){}
	public void referencesHelp(){}
	public void aboutHelp(){}
	public void quit(){}
	public void killDemoDialog() {}
	public void callbackAbacus(AbacusCanvas canvas, int ref){}
	public static void callbackAbacus(
			/*AbacusInterface.ACTION_SCRIPT*/
			int auxiliary, int deck,
			int rail, int number) {}
	public void callbackAbacus(AbacusCanvas canvas, String string) {}
	public void showMessage(String string) {}
	public boolean getScript() {return false;}
	public boolean getDemo() {return false;}
	public boolean getTeach() {return false;}
	public boolean getToggleSound() {return false;}
	public void playBumpAudio() {}
	public void playMoveAudio() {}
	public void playDripAudio() {}
	public boolean getRightToLeftAdd() {return false;}
	public boolean getRightToLeftMult() {return false;}
	public void setRightToLeftAdd(boolean value) {}
	public void setRightToLeftMult(boolean value) {}

	/**
	 * @param context
	 * @param attrs
	 */
	public AbacusView(Context context, AttributeSet attrs) {
		super(context, attrs);
		setFocusableInTouchMode(true);
	}

	/**
	 * @param context
	 * @param attrs
	 * @param defStyle
	 */
	public AbacusView(Context context, AttributeSet attrs, int defStyle) {
		super(context, attrs, defStyle);
		setFocusableInTouchMode(true);
	}

	public void init(Canvas canvas) {
		if (model == null) {
			model = new AbacusFormat(AbacusInterface.DEFAULT_RAILS);
			geo = null;
		}
		if (field == null) {
			field = new NumberField();
			field.resetField(AbacusInterface.DEFAULT_RAILS);
		}
		if (geo == null || geo.getCoreSize().x != getWidth()) {
			geo = new AbacusGeometry(model);
			geo.resize(getWidth(), getHeight());
			aDraw = null;
		}
		if (paint == null)
			paint = new Paint();
		aCanvas = new AbacusCanvas(model, field, geo, canvas, paint, this);
		AbacusCanvas.resizeAbacus();
		aDraw = AbacusCanvas.getDraw();
	}

	// TODO suspect code
	public static AbacusCanvas getAbacusCanvas() {
		return aCanvas;
	}

	// Have to wait until an onDraw happens I guess
	/*public static AbacusFormat getAbacusFormat() {
		return model;
	}*/

	public void callbackAbacusDemo(int auxiliary, int deck, int rail, int number) {
		/*if (leeValue && aux == AbacusInterface.LEFT_AUX)
			leftAuxAbacus.directMove(deck, rail, number);
		else if (leeValue && aux == AbacusInterface.RIGHT_AUX)
			rightAuxAbacus.directMove(deck, rail, number);
		else if (aux == AbacusInterface.PRIMARY)*/
		aCanvas.directMove(deck, rail, number);
	}

	public static void focusReact(boolean hasFocus) {
		if (aCanvas != null)
			AbacusCanvas.focusReact(hasFocus);
	}

	public static void clearAbacus() {
		if (aCanvas != null)
			aCanvas.clearAbacus();
	}

	public static void complementAbacus() {
		if (aCanvas != null)
			aCanvas.complementAbacus();
	}

	public static void undoAbacus() {
		if (aCanvas != null)
			aCanvas.undoAbacus();
	}

	public static void redoAbacus() {
		if (aCanvas != null)
			aCanvas.redoAbacus();
	}

	public static void decrementAbacus() {
		if (aCanvas != null)
			aCanvas.decrementAbacus();
	}

	public static void incrementAbacus() {
		if (aCanvas != null)
			aCanvas.incrementAbacus();
	}

	public static void changeFormatAbacus() {
		if (aCanvas != null)
			aCanvas.changeFormatAbacus();
	}

	private void notifyTextChangeListener() {
		if (null != textChangeListener) {
			textChangeListener.onTextChange(field.getDigitString());
		}
	}

	public interface TextChangeListener {
		void onTextChange(String string);
	}

	private TextChangeListener textChangeListener;

	public void setTextChangeListener(TextChangeListener listener) {
		textChangeListener = listener;
	}

	/**
	 * @see android.view.View#onDraw(android.graphics.Canvas)
	 */
	@Override
	protected void onDraw(Canvas canvas) {
		init(canvas);
		paint.setStyle(Style.STROKE);
		paint.setColor(hasFocus() ? Color.BLUE : Color.GRAY);
		//canvas.drawRect(0, 0, getWidth() - 1, getHeight() - 1, paint);
		//Graphics g = new Graphics(canvas, paint);
		aDraw.drawFrame(false);
		aDraw.drawFrame(true);
		//aDraw.drawAllBufferedBeads(g);
		aDraw.drawAllBeads();
		if (aCanvas != null) {
			aCanvas.setBeadMoveListener(new AbacusCanvas.BeadMoveListener() {
				@Override public void onBeadMove(AbacusCanvas aCanvas) {
					//String string = String.valueOf(AbacusCanvas.getDigitString());
					notifyTextChangeListener();
					invalidate();
				}
			});
		}
	}
}
